
#include <take_damage_example.h>

void OnLoadLibrary(LibraryForModule* library)
{
	 
}

void OnLoadFunction(FunctionForModule* function)
{
	
}

void OnLoadFunctionIncomplete(FunctionIncompleteForModule* function_incomplete)
{
	
}

void OnLoadVirtualFunction(VirtualFunctionForModule* virtual_function)
{
	
}

RageHookReturn OnTakeDamage(void*& id,entvars_s*& ent1,entvars_s*& ent2,float& dmg,int& dmg_bits,int& ret)
{
	Rage->write_console_ln("OnTakeDamage in module: id %d, ent1 %d, ent2 %d, dmg %f, dmg_bits %d, ret %d",
		Rage->private_to_index(id),
		Rage->entvar_to_index(ent1),
		Rage->entvar_to_index(ent2),
		dmg,
		dmg_bits,
		ret);

	return RageHookIgnored;
}

// Saving the function globally so we can call it later
FunctionForModule* fOnTakeDamage = NULL;

// This is the header of the function. You can get this in the handler respective to the function you are using
// Since we are hooking a function that is a member of a class we have to use different code for gcc and mvc++
// Check this http://en.wikipedia.org/wiki/X86_calling_conventions#thiscall
#ifdef __linux__
		typedef int (*OnTakeDamageType)(void*,entvars_s*,entvars_s*,float,int);
#else
		typedef int (_fastcall *OnTakeDamageType)(void*,DUMMY,entvars_s*,entvars_s*,float,int);
#endif

void ClientCommand(edict_t *pEntity)
{
	if(!fOnTakeDamage)
		return;

	if(strcmp(g_engfuncs.pfnCmd_Argv(0),"mkdmgm") || g_engfuncs.pfnCmd_Argc() != 1)
		return;

	OnTakeDamageType OnTakeDamage = (OnTakeDamageType) fOnTakeDamage->get_managed_address();

	void* player_private = Rage->index_to_private(ENTINDEX(pEntity));

	entvars_s* player_entvars = Rage->index_to_entvar(ENTINDEX(pEntity));

	edict_t *ak47 = CREATE_ENTITY();
	CALL_GAME_ENTITY(PLID,"weapon_ak47",&ak47->v);
	
	entvars_s* ak47_entvars = Rage->index_to_entvar(ENTINDEX(ak47));

#ifdef __linux__
	int ret = OnTakeDamage(
				player_private,
				ak47_entvars,
				player_entvars,
				50.0,
				(1<<1)
				);
#else
	int ret = OnTakeDamage(
				player_private,
				DUMMY_VAL,
				ak47_entvars,
				player_entvars,
				50.0,
				(1<<1)
				);
#endif

	Rage->write_console_ln("Called with return %d",ret);
}

void OnPluginsLoaded()
{
	static bool hooked = false;

	if(!hooked)
		hooked = true;
	else 
		return;

	VirtualFunctionForModule* vf = Rage->get_virtual_function("TakeDamage");

	if(!vf)
	{
		Rage->write_console_ln("Failed to get TakeDamage virtual function");
		return;
	}

	fOnTakeDamage = vf->create_with_class("player");
	fOnTakeDamage->add_module_hook((void*)&OnTakeDamage,RageHookPost);

	// Or:
	// Rage->get_virtual_function("TakeDamage")->create_with_class("player")->add_module_hook((void*)&OnTakeDamage,RageHookPost);

}